#include "../bayos.h"
#include "../apilib/syscall.h"

/* X^bNO */
int *inthandler0d(int *esp) {
    Console::printf("stack exception\n");
    Console::printf("EIP=0x%08x\n", esp[0xb]);
    Console::printf("THREAD=%s\n",  Scheduler::current->name);
    return &(Scheduler::current->tss.esp0); /* ُI */
}

/* ʕیO */
int *inthandler0c(int *esp) {
    Console::printf("general protection\n");
    Console::printf("EIP=0x%08x\n", esp[0xb]);
    Console::printf("THREAD=%s\n",  Scheduler::current->name);
    return &(Scheduler::current->tss.esp0); /* ُI */
}

/* VXeR[ */
int *hrb_api(int arg3, int arg1, int arg5, int arg6, int func_num, int arg4, int arg2, int result) {
    Task* current = Scheduler::current;
    int ds_base   = current->ds_base;

    /*
      ۑ̂߂PUSHADɏ
      VXeR[̖߂l reg[7] ɐݒ肷邱
      reg[0] : EDI, reg[1] : ESI, reg[2] : EBP, reg[3] : ESP
      reg[4] : EBX, reg[5] : EDX, reg[6] : ECX, reg[7] : EAX
    */
    int* reg = &result + 1;

    if (func_num == API_PUTCHAR) {
        Console::putChar(arg1 & 0xff);
    }
    else if (func_num == API_PUTSTR0) {
        char* s = (char *) arg1 + ds_base;
        Console::putString(s);
    }
    else if (func_num == API_PUTSTR1) {
        char* s = (char *) arg1 + ds_base;
        for (int i = 0; i <= arg2; i++) {
            Console::putChar(s[i] & 0xff);
        }
    }
    else if (func_num == API_END) {
        return &(current->tss.esp0);
    }
    else if (func_num == API_OPENWIN) {
        byte* buffer = (byte *) arg1 + ds_base;
        int w = (arg2 >> 16) & 0xffff;
        int h = arg2 & 0xffff;
        int transparent = arg3;
        char* title = (char *) arg4 + ds_base;
        Sheet* sheet = SheetCtl::allocate();
        SheetCtl::setbuf(sheet, (word *) buffer, w, h, transparent);
        sheet->vx0 = (SheetCtl::ctl->xsize - w) / 2;
        sheet->vy0 = (SheetCtl::ctl->ysize - h) / 2;
        SheetCtl::drawFrame(sheet, title);
        SheetCtl::updown(sheet, 2);
        reg[7] = (int) sheet;
    }
    else if (func_num == API_PUTSTRWIN) {
        Sheet* sheet = (Sheet *) arg1;
        int x   = (arg2 >> 16) & 0xffff;
        int y   = arg2 & 0xffff;
        //int col = arg3;
        char* s = (char *) arg4 + ds_base;
        SheetCtl::drawString(sheet, s, x, y);
    }
    else if (func_num == API_BOXFILWIN) {
        Sheet* sheet = (Sheet *) arg1;
        int x0  = (arg2 >> 16) & 0xffff;
        int y0  = arg2 & 0xffff;
        int x1  = (arg3 >> 16) & 0xffff;
        int y1  = arg3 & 0xffff;
        int col = arg4;
        SheetCtl::fillRect(sheet, x0, y0, x1, y1, col);
    }
    else if (func_num == API_INITMALLOC) {
        // Ȃ
    }
    else if (func_num == API_MALLOC) {
        void* addr = current->memory->allocate(arg1);
        reg[7] = ((int) addr) - ds_base;
    }
    else if (func_num == API_FREE) {
        dword* addr = (dword *) arg1 + ds_base;
        current->memory->free(addr);
    }
    else if (func_num == API_POINT) {
        Sheet* sheet = (Sheet *) arg1;
        int x0  = arg2;
        int y0  = arg3;
        int col = arg4;
        SheetCtl::drawPixel(sheet, x0, y0, col);
    }
    else if (func_num == API_REFRESHWIN) {
        Sheet* sheet = (Sheet *) arg1;
        int x0 = (arg2 >> 16) & 0xffff;
        int y0 = arg2 & 0xffff;
        int x1 = (arg3 >> 16) & 0xffff;
        int y1 = arg3 & 0xffff;
        SheetCtl::refresh(sheet, x0, y0, x1, y1);
    }
    else if (func_num == API_LINEWIN) {
        Sheet* sheet = (Sheet *) arg1;
        int x0  = (arg2 >> 16) & 0xffff;
        int y0  = arg2 & 0xffff;
        int x1  = (arg3 >> 16) & 0xffff;
        int y1  = arg3 & 0xffff;
        int col = arg4;
        SheetCtl::drawLine(sheet, x0, y0, x1, y1, col);
    }
    else if (func_num == API_CLOSEWIN) {
        Sheet* sheet = (Sheet *) arg1;
        SheetCtl::dispose(sheet);
        delete(sheet->buffer);
        delete(sheet);
    }
    else if (func_num == API_GETKEY) {
        if (Scheduler::task_list[TASK_IDLE]->fifo->isEmpty() == false) {
            Message* message = Scheduler::task_list[TASK_IDLE]->fifo->removeAt(0);
            reg[7] = message->arg1;
            delete(message);
        } else {
            reg[7] = 0;
        }
    }
    else if (func_num == API_ALLOCTIMER) {
        // Ȃ
    }
    else if (func_num == API_INITTIMER) {
        // Ȃ
    }
    else if (func_num == API_SETTIMER) {
        // Ȃ
    }
    else if (func_num == API_FREETIMER) {
        // Ȃ
    }
    else if (func_num == API_BEEP) {
        Beep::tone(arg1);
    }
    else if (func_num == API_FOPEN) {
        char* s = (char *) arg1 + ds_base;
        FileEntry* entry = File::load(s);
        reg[7] = (int) entry;
    }
    else if (func_num == API_FCLOSE) {
        // Ȃ
    }
    else if (func_num == API_FSIZE) {
        FileEntry* entry = (FileEntry *) arg1;
        if (entry != NULL) {
            reg[7] = entry->size;
        } else {
            reg[7] = 0;
        }
    }
    else if (func_num == API_FSEEK) {
        // Ȃ
    }
    else if (func_num == API_FREAD) {
        char* s = (char *) arg1 + ds_base;
        int maxsize = arg2;
        FileEntry* entry = (FileEntry *) arg3;
        if (entry != NULL) {
            memcpy(s, entry->data, maxsize);
            reg[7] = entry->size;
        } else {
            reg[7] = 0;
        }
    }
    else if (func_num == API_CMDLINE) {
        // Ȃ
    }
    else if (func_num == API_GETLANG) {
        // Ȃ
    }
    else if (func_num == TOMO_GETMOUSE) {
        int tx, ty;
        /* ʂ̍ォ̐΍W */
        if (arg1 == 0) {
            tx = ty = 0;
        /* ~̍ォ̑΍W */
        } else {
            Sheet* sheet = (Sheet *) arg1;
            tx = sheet->vx0;
            ty = sheet->vy0;
        }
        /* }EX̐ݒ */
        MOUSE_INFO* info = (MOUSE_INFO *) (arg2 + ds_base);
        info->x = Mouse::x - tx;
        info->y = Mouse::y - ty;
        info->button = Mouse::button;
        info->state  = Mouse::state;
    }
    else if (func_num == TOMO_GETTICK) {
        reg[7] = PIT::count;
    }
    else if (func_num == TOMO_RDMSR) {
        // Ȃ
    }
    else if (func_num == TOMO_SETLANG) {
        // Ȃ
    }
    else if (func_num == TOMO_SYSINFO) {
        BOOT_PARAM *boot_param = (BOOT_PARAM *) ADR_BOOTINFO;
        SYS_INFO* info = (SYS_INFO *) (arg1 + ds_base);
        info->cyls = boot_param->cyls;
        info->leds = boot_param->leds;
        info->bpps = boot_param->bpps;
        info->reserve  = boot_param->reserve;
        info->screen_x = boot_param->screen_x;
        info->screen_y = boot_param->screen_y;
        info->vram = boot_param->vram;
        info->os_type = 3; /* BayOS */
    }
    else if (func_num == TOMO_SYSTIME) {
        RTC::init();
        TIME_INFO* info = (TIME_INFO *) (arg1 + ds_base);
        info->year    = RTC::year;
        info->month   = RTC::month;
        info->day     = RTC::day;
        info->hour    = RTC::hour;
        info->minutes = RTC::minutes;
        info->second  = RTC::second;
    }
    else if (func_num == TOMO_WRMSR) {
        // Ȃ
    }

    return 0; /* 0ȊOԂƃAvI */
}
